diff --git a/plugins/org.teiid.designer.jdbc/src/org/teiid/designer/jdbc/i18n.properties b/plugins/org.teiid.designer.jdbc/src/org/teiid/designer/jdbc/i18n.properties
index d8091c1..f332441 100644
--- a/plugins/org.teiid.designer.jdbc/src/org/teiid/designer/jdbc/i18n.properties
+++ b/plugins/org.teiid.designer.jdbc/src/org/teiid/designer/jdbc/i18n.properties
@@ -138,6 +138,7 @@
 JdbcDatabaseImpl.Unable_to_obtain_the_database_URL=Unable to obtain the database URL on {0}
 JdbcDatabaseImpl.Unable_to_obtain_the_database_read-only_mode=Unable to obtain the database read-only mode on {0}
 JdbcDatabaseImpl.Unable_to_obtain_the_username=Unable to obtain the username on {0}
+JdbcDatabaseImpl.Unable_to_obtain_the_catalog_separator=Unable to obtain the catalog separator on {0}
 JdbcDatabaseImpl.Error_while_processing_database_information=Error while processing database information on {0}
 JdbcDatabaseImpl.Error_while_getting_the_database_metadata_component=Error while getting the database metadata component
 JdbcDatabaseImpl.DatabaseTypeName=Database
diff --git a/plugins/org.teiid.designer.jdbc/src/org/teiid/designer/jdbc/metadata/DatabaseInfo.java b/plugins/org.teiid.designer.jdbc/src/org/teiid/designer/jdbc/metadata/DatabaseInfo.java
index beb767d..2b4f258 100644
--- a/plugins/org.teiid.designer.jdbc/src/org/teiid/designer/jdbc/metadata/DatabaseInfo.java
+++ b/plugins/org.teiid.designer.jdbc/src/org/teiid/designer/jdbc/metadata/DatabaseInfo.java
@@ -77,4 +77,11 @@
      */
     boolean isReadOnly();
 
+    /**
+     * Return the catalog separator string
+     * @return the separator
+     * @see java.sql.DatabaseMetaData#getCatalogSeparator()
+     */
+	String getCatalogSeparator();
+
 }
diff --git a/plugins/org.teiid.designer.jdbc/src/org/teiid/designer/jdbc/metadata/impl/DatabaseInfoImpl.java b/plugins/org.teiid.designer.jdbc/src/org/teiid/designer/jdbc/metadata/impl/DatabaseInfoImpl.java
index c830702..59db219 100644
--- a/plugins/org.teiid.designer.jdbc/src/org/teiid/designer/jdbc/metadata/impl/DatabaseInfoImpl.java
+++ b/plugins/org.teiid.designer.jdbc/src/org/teiid/designer/jdbc/metadata/impl/DatabaseInfoImpl.java
@@ -25,6 +25,7 @@
     private String databaseURL;
     private String userName;
     private boolean readOnly;
+    private String catalogSeparator;
 
     /**
      * Construct an instance of DatabaseInfoImpl.
@@ -169,4 +170,12 @@
         this.userName = username;
     }
 
+	public String getCatalogSeparator() {
+		return catalogSeparator;
+	}
+
+	public void setCatalogSeparator(String catalogSeparator) {
+		this.catalogSeparator = catalogSeparator;
+	}
+
 }
diff --git a/plugins/org.teiid.designer.jdbc/src/org/teiid/designer/jdbc/metadata/impl/JdbcDatabaseImpl.java b/plugins/org.teiid.designer.jdbc/src/org/teiid/designer/jdbc/metadata/impl/JdbcDatabaseImpl.java
index a34bbc0..738b191 100644
--- a/plugins/org.teiid.designer.jdbc/src/org/teiid/designer/jdbc/metadata/impl/JdbcDatabaseImpl.java
+++ b/plugins/org.teiid.designer.jdbc/src/org/teiid/designer/jdbc/metadata/impl/JdbcDatabaseImpl.java
@@ -413,7 +413,7 @@
                                               IStatus.ERROR,
                                               JdbcPlugin.PLUGIN_ID,
                                               0,
-                                              JdbcPlugin.Util.getString("DatabaseInfoImpl.Unable_to_obtain_the_product_name", metadata), e); //$NON-NLS-1$
+                                              JdbcPlugin.Util.getString("JdbcDatabaseImpl.Unable_to_obtain_the_product_name", metadata), e); //$NON-NLS-1$
             statuses.add(status);
         }
 
@@ -425,7 +425,7 @@
                                               IStatus.ERROR,
                                               JdbcPlugin.PLUGIN_ID,
                                               0,
-                                              JdbcPlugin.Util.getString("DatabaseInfoImpl.Unable_to_obtain_the_product_version", metadata), e); //$NON-NLS-1$
+                                              JdbcPlugin.Util.getString("JdbcDatabaseImpl.Unable_to_obtain_the_product_version", metadata), e); //$NON-NLS-1$
             statuses.add(status);
         }
 
@@ -441,7 +441,7 @@
                                               IStatus.ERROR,
                                               JdbcPlugin.PLUGIN_ID,
                                               0,
-                                              JdbcPlugin.Util.getString("DatabaseInfoImpl.Unable_to_obtain_the_driver_name", metadata), e); //$NON-NLS-1$
+                                              JdbcPlugin.Util.getString("JdbcDatabaseImpl.Unable_to_obtain_the_driver_name", metadata), e); //$NON-NLS-1$
             statuses.add(status);
         }
 
@@ -453,7 +453,7 @@
                                               IStatus.ERROR,
                                               JdbcPlugin.PLUGIN_ID,
                                               0,
-                                              JdbcPlugin.Util.getString("DatabaseInfoImpl.Unable_to_obtain_the_driver_version", metadata), e); //$NON-NLS-1$
+                                              JdbcPlugin.Util.getString("JdbcDatabaseImpl.Unable_to_obtain_the_driver_version", metadata), e); //$NON-NLS-1$
             statuses.add(status);
         }
 
@@ -465,7 +465,7 @@
                                               IStatus.ERROR,
                                               JdbcPlugin.PLUGIN_ID,
                                               0,
-                                              JdbcPlugin.Util.getString("DatabaseInfoImpl.Unable_to_obtain_the_database_URL", metadata), e); //$NON-NLS-1$
+                                              JdbcPlugin.Util.getString("JdbcDatabaseImpl.Unable_to_obtain_the_database_URL", metadata), e); //$NON-NLS-1$
             statuses.add(status);
         }
 
@@ -477,7 +477,7 @@
                                               IStatus.ERROR,
                                               JdbcPlugin.PLUGIN_ID,
                                               0,
-                                              JdbcPlugin.Util.getString("DatabaseInfoImpl.Unable_to_obtain_the_database_read-only_mode", metadata), e); //$NON-NLS-1$
+                                              JdbcPlugin.Util.getString("JdbcDatabaseImpl.Unable_to_obtain_the_database_read-only_mode", metadata), e); //$NON-NLS-1$
             statuses.add(status);
         }
 
@@ -489,16 +489,29 @@
                                               IStatus.ERROR,
                                               JdbcPlugin.PLUGIN_ID,
                                               0,
-                                              JdbcPlugin.Util.getString("DatabaseInfoImpl.Unable_to_obtain_the_username", metadata), e); //$NON-NLS-1$
+                                              JdbcPlugin.Util.getString("JdbcDatabaseImpl.Unable_to_obtain_the_username", metadata), e); //$NON-NLS-1$
             statuses.add(status);
         }
+        
+        // Load the separator
+        try {
+            obj.setCatalogSeparator(metadata.getCatalogSeparator());
+        } catch (SQLException e) {
+            final IStatus status = new Status(
+                                              IStatus.ERROR,
+                                              JdbcPlugin.PLUGIN_ID,
+                                              0,
+                                              JdbcPlugin.Util.getString("JdbcDatabaseImpl.Unable_to_obtain_the_catalog_separator", metadata), e); //$NON-NLS-1$
+            statuses.add(status);
+        }
+
 
         // Assemble all of the individual errors into the MultiStatus
         if (statuses.size() != 0) {
             final MultiStatus mstatus = new MultiStatus(
                                                         JdbcPlugin.PLUGIN_ID,
                                                         0,
-                                                        JdbcPlugin.Util.getString("DatabaseInfoImpl.Error_while_processing_database_information", metadata), null); //$NON-NLS-1$
+                                                        JdbcPlugin.Util.getString("JdbcDatabaseImpl.Error_while_processing_database_information", metadata), null); //$NON-NLS-1$
             final Iterator iter = statuses.iterator();
             while (iter.hasNext()) {
                 final IStatus status = (IStatus)iter.next();