diff --git a/buildchow/configs/default/generated-old/master/job/devstudio.versionwatch_master/config.xml b/home/nboldt/truu/ci/cache/https/jenkins.mw.lab.eng.bos.redhat.com/hudson/view/DevStudio/view/DevStudio_Master/job/devstudio.versionwatch_master/config.xml
index e6b26b2..3b1d804 100644
--- a/buildchow/configs/default/generated-old/master/job/devstudio.versionwatch_master/config.xml
+++ b/home/nboldt/truu/ci/cache/https/jenkins.mw.lab.eng.bos.redhat.com/hudson/view/DevStudio/view/DevStudio_Master/job/devstudio.versionwatch_master/config.xml
@@ -1,40 +1,24 @@
-<?xml version="1.0" encoding="utf-8"?>
+<?xml version="1.0" encoding="UTF-8"?>
 <project>
-  <jdk>jdk1.8</jdk>
   <actions/>
   <description>Bundle version control for JBDS&lt;br/&gt;
 Maintainers: jpeterka, nboldt&lt;br/&gt;
 Latest reports: &lt;a href=ws/sources&gt;ws/sources&lt;/a&gt;*.html&lt;br/&gt;
 &lt;!-- Managed by Jenkins Job Builder --&gt;</description>
-  <keepDependencies>false</keepDependencies>
-  <disabled>false</disabled>
-  <blockBuildWhenDownstreamBuilding>false</blockBuildWhenDownstreamBuilding>
-  <blockBuildWhenUpstreamBuilding>false</blockBuildWhenUpstreamBuilding>
-  <concurrentBuild>false</concurrentBuild>
-  <assignedNode>(RHEL6||RHEL7||beaker||jboss-prod)&amp;&amp;!ia64&amp;&amp;!ppc64&amp;&amp;!rhts</assignedNode>
-  <canRoam>false</canRoam>
-  <logRotator>
+  <logRotator class="hudson.tasks.LogRotator">
     <daysToKeep>10</daysToKeep>
     <numToKeep>10</numToKeep>
     <artifactDaysToKeep>10</artifactDaysToKeep>
     <artifactNumToKeep>10</artifactNumToKeep>
   </logRotator>
+  <keepDependencies>false</keepDependencies>
   <properties>
-    <com.coravy.hudson.plugins.github.GithubProjectProperty>
+    <com.coravy.hudson.plugins.github.GithubProjectProperty plugin="github@1.11.3">
       <projectUrl>https://github.com/jbosstools/jbosstools-versionwatch/</projectUrl>
     </com.coravy.hudson.plugins.github.GithubProjectProperty>
-    <com.chikli.hudson.plugin.naginator.NaginatorOptOutProperty>
+    <com.chikli.hudson.plugin.naginator.NaginatorOptOutProperty plugin="naginator@1.15">
       <optOut>false</optOut>
     </com.chikli.hudson.plugin.naginator.NaginatorOptOutProperty>
-    <EnvInjectJobProperty>
-      <info>
-        <loadFilesFromMaster>false</loadFilesFromMaster>
-      </info>
-      <on>true</on>
-      <keepJenkinsSystemVariables>true</keepJenkinsSystemVariables>
-      <keepBuildVariables>true</keepBuildVariables>
-      <overrideBuildParameters>false</overrideBuildParameters>
-    </EnvInjectJobProperty>
     <hudson.model.ParametersDefinitionProperty>
       <parameterDefinitions>
         <hudson.model.StringParameterDefinition>
@@ -49,8 +33,21 @@ Latest reports: &lt;a href=ws/sources&gt;ws/sources&lt;/a&gt;*.html&lt;br/&gt;
         </hudson.model.StringParameterDefinition>
       </parameterDefinitions>
     </hudson.model.ParametersDefinitionProperty>
+    <com.sonyericsson.rebuild.RebuildSettings plugin="rebuild@1.22">
+      <autoRebuild>false</autoRebuild>
+    </com.sonyericsson.rebuild.RebuildSettings>
+    <EnvInjectJobProperty plugin="envinject@1.91.2">
+      <info>
+        <loadFilesFromMaster>false</loadFilesFromMaster>
+      </info>
+      <on>true</on>
+      <keepJenkinsSystemVariables>true</keepJenkinsSystemVariables>
+      <keepBuildVariables>true</keepBuildVariables>
+      <overrideBuildParameters>false</overrideBuildParameters>
+      <contributors/>
+    </EnvInjectJobProperty>
   </properties>
-  <scm class="hudson.plugins.git.GitSCM">
+  <scm class="hudson.plugins.git.GitSCM" plugin="git@2.3.5">
     <configVersion>2</configVersion>
     <userRemoteConfigs>
       <hudson.plugins.git.UserRemoteConfig>
@@ -64,35 +61,30 @@ Latest reports: &lt;a href=ws/sources&gt;ws/sources&lt;/a&gt;*.html&lt;br/&gt;
         <name>origin/master</name>
       </hudson.plugins.git.BranchSpec>
     </branches>
-    <excludedUsers/>
-    <buildChooser class="hudson.plugins.git.util.DefaultBuildChooser"/>
-    <disableSubmodules>false</disableSubmodules>
-    <recursiveSubmodules>false</recursiveSubmodules>
     <doGenerateSubmoduleConfigurations>false</doGenerateSubmoduleConfigurations>
-    <authorOrCommitter>false</authorOrCommitter>
-    <wipeOutWorkspace>true</wipeOutWorkspace>
-    <pruneBranches>false</pruneBranches>
-    <remotePoll>false</remotePoll>
-    <gitTool>Default</gitTool>
+    <browser class="hudson.plugins.git.browser.GithubWeb">
+      <url>https://github.com/jbosstools/jbosstools-versionwatch/</url>
+    </browser>
     <submoduleCfg class="list"/>
-    <relativeTargetDir>sources</relativeTargetDir>
-    <reference/>
-    <gitConfigName/>
-    <gitConfigEmail/>
-    <skipTag>false</skipTag>
-    <scmName/>
-    <useShallowClone>false</useShallowClone>
-    <ignoreNotifyCommit>false</ignoreNotifyCommit>
     <extensions>
       <hudson.plugins.git.extensions.impl.WipeWorkspace/>
+      <hudson.plugins.git.extensions.impl.RelativeTargetDirectory>
+        <relativeTargetDir>sources</relativeTargetDir>
+      </hudson.plugins.git.extensions.impl.RelativeTargetDirectory>
+      <hudson.plugins.git.extensions.impl.PerBuildTag/>
     </extensions>
-    <browser class="hudson.plugins.git.browser.GithubWeb">
-      <url>https://github.com/jbosstools/jbosstools-versionwatch/</url>
-    </browser>
   </scm>
+  <assignedNode>(RHEL6||RHEL7||beaker||jboss-prod)&amp;&amp;!ia64&amp;&amp;!ppc64&amp;&amp;!rhts</assignedNode>
+  <canRoam>false</canRoam>
+  <disabled>false</disabled>
+  <blockBuildWhenDownstreamBuilding>false</blockBuildWhenDownstreamBuilding>
+  <blockBuildWhenUpstreamBuilding>false</blockBuildWhenUpstreamBuilding>
+  <jdk>jdk1.8</jdk>
+  <triggers/>
+  <concurrentBuild>false</concurrentBuild>
   <builders>
     <hudson.tasks.Shell>
-      <command>. ${WORKSPACE}/sources/run.jenkins.job.sh -INCLUDE_VERSIONS &quot;(8|9)\.\d+\.\d+&quot; -INCLUDE_IUS &quot;${INCLUDE_IUS}&quot; -EXCLUDE_IUS &quot;${EXCLUDE_IUS}&quot; -JAVA_HOME &quot;${NATIVE_TOOLS}${SEP}${JAVA18}&quot; -DTRACE=true
+      <command>. ${WORKSPACE}/sources/run.jenkins.job.sh -INCLUDE_VERSIONS "(8|9)\.\d+\.\d+" -INCLUDE_IUS "${INCLUDE_IUS}" -EXCLUDE_IUS "${EXCLUDE_IUS}" -JAVA_HOME "${NATIVE_TOOLS}${SEP}${JAVA18}" -DTRACE=true
 </command>
     </hudson.tasks.Shell>
   </builders>
@@ -100,36 +92,37 @@ Latest reports: &lt;a href=ws/sources&gt;ws/sources&lt;/a&gt;*.html&lt;br/&gt;
     <hudson.tasks.ArtifactArchiver>
       <artifacts>**/target/*.zip, **/target/**/*.zip, **/*.log, **/coverage-report/**, **/jacoco.exec, **/sources/*.html</artifacts>
       <excludes>.repository, .repository/*, .repository/**</excludes>
-      <latestOnly>false</latestOnly>
       <allowEmptyArchive>true</allowEmptyArchive>
+      <onlyIfSuccessful>false</onlyIfSuccessful>
       <fingerprint>false</fingerprint>
+      <defaultExcludes>true</defaultExcludes>
     </hudson.tasks.ArtifactArchiver>
-    <hudson.plugins.descriptionsetter.DescriptionSetterPublisher>
+    <hudson.plugins.descriptionsetter.DescriptionSetterPublisher plugin="description-setter@1.10">
       <regexp>BUILD_DESCRIPTION='(.+)'</regexp>
       <regexpForFailed>.*(no installation folders found|Incorrect version format).*</regexpForFailed>
       <description>\1</description>
       <descriptionForFailed>\1</descriptionForFailed>
       <setForMatrix>false</setForMatrix>
     </hudson.plugins.descriptionsetter.DescriptionSetterPublisher>
-    <hudson.plugins.textfinder.TextFinderPublisher>
+    <hudson.plugins.textfinder.TextFinderPublisher plugin="text-finder@1.10">
       <regexp>.*(^ERROR |FAILURE IN OUTPUT: ).*</regexp>
-      <alsoCheckConsoleOutput>true</alsoCheckConsoleOutput>
       <succeedIfFound>false</succeedIfFound>
       <unstableIfFound>true</unstableIfFound>
+      <alsoCheckConsoleOutput>true</alsoCheckConsoleOutput>
     </hudson.plugins.textfinder.TextFinderPublisher>
   </publishers>
   <buildWrappers>
-    <hudson.plugins.build__timeout.BuildTimeoutWrapper>
+    <hudson.plugins.build__timeout.BuildTimeoutWrapper plugin="build-timeout@1.14.1">
+      <strategy class="hudson.plugins.build_timeout.impl.AbsoluteTimeOutStrategy">
         <timeoutMinutes>20</timeoutMinutes>
+      </strategy>
       <timeoutEnvVar>build_timeout</timeoutEnvVar>
-      <failBuild>false</failBuild>
-      <writingDescription>build timed out &amp; aborted after ${build_timeout} minutes.</writingDescription>
-      <timeoutPercentage>0</timeoutPercentage>
-      <timeoutMinutesElasticDefault>3</timeoutMinutesElasticDefault>
-      <timeoutType>absolute</timeoutType>
+      <operationList>
+        <hudson.plugins.build__timeout.operations.AbortOperation/>
+      </operationList>
     </hudson.plugins.build__timeout.BuildTimeoutWrapper>
-    <hudson.plugins.timestamper.TimestamperBuildWrapper/>
-    <hudson.plugins.xvnc.Xvnc>
+    <hudson.plugins.timestamper.TimestamperBuildWrapper plugin="timestamper@1.6"/>
+    <hudson.plugins.xvnc.Xvnc plugin="xvnc@1.21">
       <takeScreenshot>false</takeScreenshot>
       <useXauthority>true</useXauthority>
     </hudson.plugins.xvnc.Xvnc>